// Programm 4-8:  ./JDBCelementar/SimplePrepStatement.java 
import java.sql.*;
public class SimplePrepStatement {
  public SimplePrepStatement(String par) {
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      Connection c = DriverManager.getConnection(
                     "jdbc:oracle:thin:@p30:1521:orcl",
                     "Kurse", "Oracle");
      String sql = 
                "SELECT * FROM Personen WHERE nachname LIKE ?";
      PreparedStatement ps = c.prepareStatement(sql);
      ps.setString(1, par);
      ResultSet r = ps.executeQuery();
      while(r.next())
        System.out.println(
               r.getString("nachname") + ", " +
               r.getString("vorname"));
    }
    catch (Exception ex) {ex.printStackTrace();}
  }
  public static void main(String[] args) {
    new SimplePrepStatement(
                      args.length == 0 ?  "%" : args[0] + "%");
  }
}                            // Ende class SimplePrepStatement
